function _aws_cdk_aws_kinesisfirehose_alpha_IDeliveryStream(p) {
}
function _aws_cdk_aws_kinesisfirehose_alpha_StreamEncryptionType(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        print("@aws-cdk/aws-kinesisfirehose-alpha.StreamEncryptionType", "");
        const ns = require("./lib/delivery-stream.js");
        if (Object.values(ns.StreamEncryptionType).filter(x => x === p).length > 1)
            return;
        if (p === ns.StreamEncryptionType.UNENCRYPTED)
            print("@aws-cdk/aws-kinesisfirehose-alpha.StreamEncryptionType#UNENCRYPTED", "");
        if (p === ns.StreamEncryptionType.CUSTOMER_MANAGED)
            print("@aws-cdk/aws-kinesisfirehose-alpha.StreamEncryptionType#CUSTOMER_MANAGED", "");
        if (p === ns.StreamEncryptionType.AWS_OWNED)
            print("@aws-cdk/aws-kinesisfirehose-alpha.StreamEncryptionType#AWS_OWNED", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_kinesisfirehose_alpha_DeliveryStreamProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("destination" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DeliveryStreamProps#destination", "");
        if (!visitedObjects.has(p.destination))
            _aws_cdk_aws_kinesisfirehose_alpha_IDestination(p.destination);
        if ("deliveryStreamName" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DeliveryStreamProps#deliveryStreamName", "");
        if ("encryption" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DeliveryStreamProps#encryption", "");
        if (!visitedObjects.has(p.encryption))
            _aws_cdk_aws_kinesisfirehose_alpha_StreamEncryption(p.encryption);
        if ("role" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DeliveryStreamProps#role", "");
        if ("source" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DeliveryStreamProps#source", "");
        if (!visitedObjects.has(p.source))
            _aws_cdk_aws_kinesisfirehose_alpha_ISource(p.source);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_kinesisfirehose_alpha_DeliveryStreamAttributes(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("deliveryStreamArn" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DeliveryStreamAttributes#deliveryStreamArn", "");
        if ("deliveryStreamName" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DeliveryStreamAttributes#deliveryStreamName", "");
        if ("role" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DeliveryStreamAttributes#role", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_kinesisfirehose_alpha_DeliveryStream(p) {
}
function _aws_cdk_aws_kinesisfirehose_alpha_ISource(p) {
}
function _aws_cdk_aws_kinesisfirehose_alpha_KinesisStreamSource(p) {
}
function _aws_cdk_aws_kinesisfirehose_alpha_DestinationConfig(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("dependables" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DestinationConfig#dependables", "");
        if ("extendedS3DestinationConfiguration" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DestinationConfig#extendedS3DestinationConfiguration", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_kinesisfirehose_alpha_DestinationBindOptions(p) {
}
function _aws_cdk_aws_kinesisfirehose_alpha_IDestination(p) {
}
function _aws_cdk_aws_kinesisfirehose_alpha_StreamEncryption(p) {
}
function _aws_cdk_aws_kinesisfirehose_alpha_LambdaFunctionProcessor(p) {
}
function _aws_cdk_aws_kinesisfirehose_alpha_DataProcessorProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("bufferInterval" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DataProcessorProps#bufferInterval", "");
        if ("bufferSize" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DataProcessorProps#bufferSize", "");
        if ("retries" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DataProcessorProps#retries", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_kinesisfirehose_alpha_DataProcessorIdentifier(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("parameterName" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DataProcessorIdentifier#parameterName", "");
        if ("parameterValue" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DataProcessorIdentifier#parameterValue", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_kinesisfirehose_alpha_DataProcessorConfig(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("processorIdentifier" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DataProcessorConfig#processorIdentifier", "");
        if (!visitedObjects.has(p.processorIdentifier))
            _aws_cdk_aws_kinesisfirehose_alpha_DataProcessorIdentifier(p.processorIdentifier);
        if ("processorType" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DataProcessorConfig#processorType", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_kinesisfirehose_alpha_DataProcessorBindOptions(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("role" in p)
            print("@aws-cdk/aws-kinesisfirehose-alpha.DataProcessorBindOptions#role", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_kinesisfirehose_alpha_IDataProcessor(p) {
}
function print(name, deprecationMessage) {
    const deprecated = process.env.JSII_DEPRECATED;
    const deprecationMode = ["warn", "fail", "quiet"].includes(deprecated) ? deprecated : "warn";
    const message = `${name} is deprecated.\n  ${deprecationMessage.trim()}\n  This API will be removed in the next major release.`;
    switch (deprecationMode) {
        case "fail":
            throw new DeprecationError(message);
        case "warn":
            console.warn("[WARNING]", message);
            break;
    }
}
function getPropertyDescriptor(obj, prop) {
    const descriptor = Object.getOwnPropertyDescriptor(obj, prop);
    if (descriptor) {
        return descriptor;
    }
    const proto = Object.getPrototypeOf(obj);
    const prototypeDescriptor = proto && getPropertyDescriptor(proto, prop);
    if (prototypeDescriptor) {
        return prototypeDescriptor;
    }
    return {};
}
const visitedObjects = new Set();
class DeprecationError extends Error {
    constructor(...args) {
        super(...args);
        Object.defineProperty(this, "name", {
            configurable: false,
            enumerable: true,
            value: "DeprecationError",
            writable: false,
        });
    }
}
module.exports = { print, getPropertyDescriptor, DeprecationError, _aws_cdk_aws_kinesisfirehose_alpha_IDeliveryStream, _aws_cdk_aws_kinesisfirehose_alpha_StreamEncryptionType, _aws_cdk_aws_kinesisfirehose_alpha_DeliveryStreamProps, _aws_cdk_aws_kinesisfirehose_alpha_DeliveryStreamAttributes, _aws_cdk_aws_kinesisfirehose_alpha_DeliveryStream, _aws_cdk_aws_kinesisfirehose_alpha_ISource, _aws_cdk_aws_kinesisfirehose_alpha_KinesisStreamSource, _aws_cdk_aws_kinesisfirehose_alpha_DestinationConfig, _aws_cdk_aws_kinesisfirehose_alpha_DestinationBindOptions, _aws_cdk_aws_kinesisfirehose_alpha_IDestination, _aws_cdk_aws_kinesisfirehose_alpha_StreamEncryption, _aws_cdk_aws_kinesisfirehose_alpha_LambdaFunctionProcessor, _aws_cdk_aws_kinesisfirehose_alpha_DataProcessorProps, _aws_cdk_aws_kinesisfirehose_alpha_DataProcessorIdentifier, _aws_cdk_aws_kinesisfirehose_alpha_DataProcessorConfig, _aws_cdk_aws_kinesisfirehose_alpha_DataProcessorBindOptions, _aws_cdk_aws_kinesisfirehose_alpha_IDataProcessor };
